--
-- katrTrigger
--
-- MOD by Defender
--

print("MapMOD: katrTrigger loaded");

katrTrigger = {};

_G.katrOnCreate = function(id)
	katrTrigger:triggerLoad(id);
end;

function katrTrigger:triggerLoad(id)
  addTrigger(id, "katrTriggerCallback", self);
  self.barnMoverTriggerSound = createSample("barnMoverTriggerSound");
  loadSample(self.barnMoverTriggerSound, "data/maps/sounds/cashRegistry.wav", false);    
end;

function katrTrigger:loadMap(name)
end;

function katrTrigger:deleteMap()
end;

function katrTrigger:delete()
end;

function katrTrigger:mouseEvent(posX, posY, isDown, isUp, button)
end;

function katrTrigger:keyEvent(unicode, sym, modifier, isDown)
end;

function katrTrigger:update(dt)
end;

function katrTrigger:draw()
end;

function katrTrigger:katrTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
  if onEnter then
    -- this happens, if a compound child of a deleted compound is entering
    if otherId ~= 0 then
      local isTrunk = getUserAttribute(otherId, "isTrunk");

      if (isTrunk ~= nil and isTrunk) then
        local difficultyMultiplier = 2 ^ (3 - g_currentMission.missionStats.difficulty);
        local baseValue = 800;
        g_currentMission.missionStats.money = g_currentMission.missionStats.money + baseValue * difficultyMultiplier;
        g_currentMission:removeItemToSave(otherId);
        if self.barnMoverTriggerSound ~= nil then
          playSample(self.barnMoverTriggerSound, 1, 1, 0);
        end;       
        delete(otherId);
      end;      
    end;
  end;
end;

addModEventListener(katrTrigger);
